summaryrefslogtreecommitdiffstats
path: root/test
diff options
context:
space:
mode:
Diffstat (limited to '')
-rwxr-xr-xtest588
-rw-r--r--testcases/errors-LINUX-AMD64150
-rw-r--r--testcases/errors-LINUX-PARISC_32152
l---------testcases/errors-LINUX-PARISC_641
-rw-r--r--testcases/signals-LINUX-AMD6464
-rw-r--r--testutil/get-datatype-description.c52
-rw-r--r--testutil/get-error.c27
-rw-r--r--testutil/get-section-fraction.c24
-rw-r--r--testutil/get-signals.c43
-rw-r--r--testutil/get-syscall-errors.c43
-rw-r--r--testutil/get-syscall-range.c41
-rw-r--r--testutil/is-datatype-struct.c29
-rw-r--r--testutil/is-section-half.c14
-rw-r--r--testutil/is-section-quarter.c14
-rw-r--r--testutil/list-errors.c21
-rw-r--r--testutil/perror-all.c23
-rw-r--r--testutil/perror-bad.c23
-rw-r--r--testutil/strerror-all.c25
-rw-r--r--testutil/strerror-bad.c25
19 files changed, 1359 insertions, 0 deletions
diff --git a/test b/test
new file mode 100755
index 0000000..803f45f
--- /dev/null
+++ b/test
@@ -0,0 +1,588 @@
+#!/bin/sh
+# See LICENSE file for copyright and license details.
+
+if test $# = 0; then
+ if "$0" fail for me; then
+ printf 'Testing is broken!\n' >&2
+ exit 2
+ fi
+ "$0" $$
+ r=$?
+ rm -f -- .?-$$.tmp
+ exit $r
+fi
+
+
+set -e
+test $# = 1
+pid=$1
+a=.a-$pid.tmp
+b=.b-$pid.tmp
+PATH="$(dirname -- "$0")/testutil:$PATH"
+export PATH
+
+
+
+stderr () {
+ ("$@") 2>&1 >/dev/null
+}
+
+getlist () {
+ getlist_list="$1"
+ shift 1
+ if test $# = 0; then set cat; fi
+ "$@" < libsyscalls.h \
+ | tr , '\n' \
+ | sed -n 's/^\s*LIBSYSCALLS_'"${getlist_list}"'_\([A-Z0-9_]\+\(\s*=\s*[ 0-9A-Fa-fxXULul()^&|!*/<>~+-]\+\)\?\)\b.*$/\1/p' \
+ | tr = ' ' \
+ | (i=0; while read name value; do
+ if test -n "$value"; then
+ i=$(( $(printf '%s\n' "$value" | tr -d 'ULul') ))
+ i=$(printf '%s\n' "$i" | cut -d . -f 1)
+ fi
+ printf '%i %s\n' $(( i++ )) $name;
+ done)
+}
+
+getnamelist () {
+ getlist "$@" | cut -d ' ' -f 2
+}
+
+getnumlist () {
+ getlist "$@" | cut -d ' ' -f 1
+}
+
+getname () {
+ (getlist "$1" | grep "^$2 " | cut -d ' ' -f 2 | tee /dev/stderr | grep . >/dev/null) 2>&1
+}
+
+getnum () {
+ (getlist "$1" | grep " $2"\$ | cut -d ' ' -f 1 | tee /dev/stderr | grep . >/dev/null) 2>&1
+}
+
+lookupname () {
+ (printf '%s\n' "$1" | grep "^$2 " | cut -d ' ' -f 2 | tee /dev/stderr | grep . >/dev/null) 2>&1
+}
+
+lookupnum () {
+ (printf '%s\n' "$1" | grep " $2"\$ | cut -d ' ' -f 1 | tee /dev/stderr | grep . >/dev/null) 2>&1
+}
+
+issupported () {
+ if test $# = 1; then
+ printf '%s\n' ${SUPPORTED_OSES} | grep -i "^$1"\$ > /dev/null
+ else
+ printf '%s\n' ${SUPPORTED_OSES} | grep -i "^$1"\$ > /dev/null &&
+ env | sed -n 's/^SUPPORTED_'"$1"'_ARCHES=//p' | xargs printf '%s\n' | grep -i "^$2"\$ > /dev/null
+ fi
+}
+
+
+
+set -v
+
+
+# self check
+(
+ set -e
+ stderr_printf () {
+ printf "$@" >&2
+ }
+ test "$(stderr_printf 'hello\n')" = ''
+ test "$(stderr stderr_printf 'hello\n' 2>&1)" = 'hello'
+ (! (false > $a) )
+ getname OS 0
+ (! getname OS)
+ getnum OS LINUX
+ (! getnum OS 0)
+ getnamelist OS | grep LINUX
+ getnamelist ARCH | grep AMD64_X32
+ getnumlist OS | grep '^0$'
+ getnumlist ARCH | grep 10
+ getnumlist OS ${CPP} | grep '^0$'
+ test -n "${CPP}"
+ test "$(getname OS 0)" = LINUX
+ test "$(getnum OS LINUX)" = 0
+ test "$(lookupnum "$(getlist OS)" LINUX)" = 0
+ test "$(lookupname "$(getlist OS)" 0)" = LINUX
+ printf 'a\n' > $a
+ printf 'b\n' > $b
+ (! diff -u $a $b)
+ printf 'a\n' > $b
+ diff -u $a $b
+ for os in ${SUPPORTED_OSES}; do
+ issupported $os
+ for arch in $(env | sed -n 's/^SUPPORTED_'"$os"'_ARCHES=//p' | xargs printf '%s\n'); do
+ issupported $os $arch
+ done
+ done
+) >/dev/null 2>/dev/null
+
+
+
+### enums ###
+
+cpp_enum_clean () {
+ $CPP < libsyscalls.h | grep -v '#' | tr '\n,{}' ' \n\n\n'
+}
+check_enum_good () {
+ test -n "$(getnamelist "$@")"
+ test -n "$(getnumlist "$@")"
+ test -z "$(getnamelist "$@" | sort | uniq -d)"
+ test -z "$(getnumlist "$@" | sort | uniq -d)"
+ (( "$(getnumlist "$@" | sort -n | sed -n \$p)" <= 0xFFFF ))
+}
+check_enum_good OS
+check_enum_good ARCH
+check_enum_good CAT
+for cat in $(getnamelist CAT); do
+ if test "$cat" = SUPPORT_PENDING || test "$cat" = NOT_IMPLEMENTED; then
+ continue
+ fi
+ check_enum_good ${cat}_SUBCAT
+ grep -i "enum.libsyscalls_${cat}_syscall_subcategory"'\s\+'"$cat"\\b < libsyscalls.h >/dev/null
+done
+check_enum_good SIGN
+check_enum_good ANNOTATION
+check_enum_good SECTION
+check_enum_good TYPE cpp_enum_clean
+types="$(getlist TYPE cpp_enum_clean)"
+
+
+
+### libsyscalls errors ###
+
+strerror-all.tu > $a
+stderr perror-all.tu > $b
+diff -u $a $b
+test $(wc -l < $a) -ge 10
+
+strerror-bad.tu > $a
+stderr perror-bad.tu > $b
+diff -u $a $b
+test $(wc -l < $a) = 2
+grep -i '\(un\|not \)recogni[sz]ed' > /dev/null < $a
+test "$(sed 1q < $a)" = "$(sed 1d < $a)"
+
+for t in perror-bad.tu perror-all.tu; do
+ stderr $t "" > $a
+ stderr $t > $b
+ diff -u $a $b
+
+ stderr $t "test" > $a
+ stderr $t > $b
+ (! diff -u $a $b >/dev/null)
+
+ stderr $t "test" > $a
+ stderr $t | sed 's/^/test: /' > $b
+ diff -u $a $b
+done
+
+strerror-all.tu > $a
+list-errors.tu > $b
+(! grep '^-' >/dev/null < $b)
+grep '^[0-9]\+ ' >/dev/null < $b
+grep '^[0-9]\+ LIBSYSCALLS_E_[A-Z]\+ ' >/dev/null < $b
+grep '^[0-9]\+ LIBSYSCALLS_E_[A-Z]\+ [A-Z].*[^.]$' >/dev/null < $b
+cut -d ' ' -f 3- < $b | diff -u $a -
+sed 1q < $b | grep '^0 LIBSYSCALLS_E_OK Success$' >/dev/null
+test -z "$(cut -d ' ' -f 1 < $b | sort | uniq -d)"
+test -z "$(cut -d ' ' -f 2 < $b | sort | uniq -d)"
+test -z "$(cut -d ' ' -f 3- < $b | sort | uniq -d)"
+
+test "$(get-error.tu LIBSYSCALLS_E_OK)" = 'Success'
+test "$(get-error.tu LIBSYSCALLS_E_OSNOSUP)" = 'Operating system not supported'
+test "$(get-error.tu LIBSYSCALLS_E_NOSUCHSYSCALL)" = 'No such system call'
+
+# This can be updated, its just to check that nothing is accidentally changed in LIBSYSCALLS_LIST_ERRORS
+cat > $a <<.
+0 LIBSYSCALLS_E_OK Success
+1 LIBSYSCALLS_E_OSNOSUP Operating system not supported
+2 LIBSYSCALLS_E_ARCHNOSUP Architecture not supported for selected operating system
+3 LIBSYSCALLS_E_NOSUCHSYSCALL No such system call
+4 LIBSYSCALLS_E_NOERRORS There is no error listing for selected operating system
+5 LIBSYSCALLS_E_NOSIGNALS There is no signal listing for selected operating system
+6 LIBSYSCALLS_E_NOMEM Failed to allocate required memory
+7 LIBSYSCALLS_E_INVAL Invalid arguments passed to function
+8 LIBSYSCALLS_E_NOSUCHTYPE Type does not exist on the selected operating system or architecture
+9 LIBSYSCALLS_E_ISSTRUCT Type is a structure or union
+.
+list-errors.tu | diff -u $a -
+
+
+
+### System call number ranges ###
+
+for os in $(getnamelist OS); do
+ osn=$(getnum OS $os)
+ for arch in $(getnamelist ARCH); do
+ archn=$(getnum ARCH $arch)
+ get-syscall-range.tu $osn $archn $os $arch > $a
+ min="$(sed -n 's/min: //p' < $a)"
+ max="$(sed -n 's/max: //p' < $a)"
+ test -n "$min"
+ test -n "$max"
+ if test $min = x || test $max = x; then
+ (! issupported $os $arch)
+ continue
+ fi
+ issupported $os $arch
+ done
+done
+check_range () {
+ if issupported $1 $2; then
+ osn=$(getnum OS $1)
+ archn=$(getnum ARCH $2)
+ get-syscall-range.tu $osn $archn $1 $2 > $a
+ min="$(sed -n 's/min: //p' < $a)"
+ max="$(sed -n 's/max: //p' < $a)"
+ test $min -le $3
+ test $max -ge $4
+ test -z "$5" || test $min -ge $5
+ fi
+}
+check_range LINUX AMD64 0 453 0
+check_range LINUX AMD64_X32 0 547 0
+check_range LINUX M68K 0 452 0
+check_range LINUX PARISC_32 0 452 0
+check_range LINUX PARISC_64 0 452 0
+check_range LINUX SPARC_32 0 452 0
+check_range LINUX I386 0 452 0
+
+
+
+### System call errors ###
+
+for os in $(getnamelist OS); do
+ osn=$(getnum OS $os)
+ for arch in $(getnamelist ARCH); do
+ archn=$(getnum ARCH $arch)
+ get-syscall-errors.tu $osn $archn $os $arch > $a
+ grep -v '^[0-9]\+ -' >/dev/null < $a
+ grep -v '^-' < $a > $b
+ grep '^\([0-9]\+\) \1 ' < $a | diff -u $a -
+ if issupported $os $arch; then
+ (! test "$(cat $a)" = x)
+ if test "$os" = LINUX; then
+ signed=1
+ grep '^[0-9]\+ [0-9]\+ [A-Z0-9_]\+$' >/dev/null < $a
+ test -z "$(grep -v '^[0-9]\+ [0-9]\+ [A-Z0-9_]\+$' < $a)"
+ required="ERESTARTSYS ERESTARTNOINTR ERESTARTNOHAND ERESTART_RESTARTBLOCK EPERM ENOENT EDOM ELOOP"
+ else
+ continue;
+ fi
+ for req in $required; do
+ grep '^-\?[0-9]\+ [0-9]\+ '"$req"\$ >/dev/null < $a
+ done
+ cut -d ' ' -f $(( 2 - signed )) < $a > $b && sort -n < $b | diff -u $b -
+ if test -f testcases/errors-$os-$arch; then
+ if ! diff -u testcases/errors-$os-$arch $a; then
+ printf '\x1b[33m%s\x1b[m\n' "Maybe new errors have been added for $os on $arch"
+ exit 1
+ fi
+ fi
+ else
+ # Can still be successful because it may be hardcorded to
+ # use the same table as another architecture that is supported,
+ # however it cannot be successful if the OS is not supported
+ issupported $os
+ fi
+ test -z "$(cut -d ' ' -f 1 < $a | sort | uniq -d)"
+ test -z "$(cut -d ' ' -f 2 < $a | sort | uniq -d)"
+ test -z "$(cut -d ' ' -f 3 < $a | sort | uniq -d)"
+ done
+done
+test -f testcases/errors-LINUX-AMD64
+test -f testcases/errors-LINUX-PARISC_32
+test -f testcases/errors-LINUX-PARISC_64
+(! diff -u testcases/errors-LINUX-AMD64 testcases/errors-LINUX-PARISC_32 >/dev/null)
+
+
+
+### Operating system signals ###
+
+for os in $(getnamelist OS); do
+ osn=$(getnum OS $os)
+ for arch in $(getnamelist ARCH); do
+ archn=$(getnum ARCH $arch)
+ get-signals.tu $osn $archn $os $arch > $a
+ grep -v '^[0-9]\+ -' >/dev/null < $a
+ grep -v '^-' < $a > $b
+ grep '^\([0-9]\+\) \1 ' < $a | diff -u $a -
+ if issupported $os $arch; then
+ (! test "$(cat $a)" = x)
+ if test "$os" = LINUX; then
+ signed=1
+ grep '^[0-9]\+ [0-9]\+ [A-Z0-9_+]\+$' >/dev/null < $a
+ test -z "$(grep -v '^[0-9]\+ [0-9]\+ [A-Z0-9_+]\+$' < $a)"
+ required="SIGKILL SIGTERM SIGCONT SIGSTOP SIGHUP _SIGRTMIN _SIGRTMIN+8"
+ else
+ continue;
+ fi
+ for req in $required; do
+ grep '^-\?[0-9]\+ [0-9]\+ '"$req"\$ >/dev/null < $a
+ done
+ cut -d ' ' -f $(( 2 - signed )) < $a > $b && sort -n < $b | diff -u $b -
+ if test -f testcases/signals-$os-$arch; then
+ if ! diff -u testcases/signals-$os-$arch $a; then
+ printf '\x1b[33m%s\x1b[m\n' "Maybe new signals have been added for $os on $arch"
+ exit 1
+ fi
+ fi
+ else
+ # Can still be successful because it may be hardcorded to
+ # use the same table as another architecture that is supported,
+ # however it cannot be successful if the OS is not supported
+ issupported $os
+ fi
+ test -z "$(cut -d ' ' -f 1 < $a | sort | uniq -d)"
+ test -z "$(cut -d ' ' -f 2 < $a | sort | uniq -d)"
+ test -z "$(cut -d ' ' -f 3 < $a | sort | uniq -d)"
+ done
+done
+test -f testcases/signals-LINUX-AMD64
+
+
+
+### Split register classifications ###
+
+test $(getnamelist SECTION | grep '_HALF$' | wc -l) -ge 8
+for sec in $(getnamelist SECTION | grep '_HALF$'); do
+ secn=$(getnum SECTION $sec)
+ is-section-half.tu $secn
+ (! is-section-quarter.tu $secn)
+ test $(get-section-fraction.tu $secn) = 2
+done
+
+test $(getnamelist SECTION | grep '_QUARTER$' | wc -l) -ge 4
+for sec in $(getnamelist SECTION | grep '_QUARTER$'); do
+ secn=$(getnum SECTION $sec)
+ is-section-quarter.tu $secn
+ (! is-section-half.tu $secn)
+ test $(get-section-fraction.tu $secn) = 4
+done
+
+secn="$(getnum SECTION WHOLE)"
+test -n "$secn"
+test $(get-section-fraction.tu $secn) = 1
+
+
+
+### Data types ###
+
+#in this test, we are assuming that char is 8 bits
+intsizes="8 16 32 64"
+cat > $b <<.
+8Little 0
+16Little 0 8
+32Little 0 8 16 24
+64Little 0 8 16 24 32 40 48 56
+8Big 0
+16Big 8 0
+32Big 24 16 8 0
+64Big 56 48 40 32 24 16 8 0
+.
+byteorders="$(cat $b)"
+getbyteorder () {
+ printf '%s\n' "$byteorders" | grep "^$1$2 " | cut -d ' ' -f 2-
+}
+
+sed '1,/LIST_ARCH_SPECS/d' < libsyscalls_get_datatype_description.c \
+| sed '/#include/q' \
+| sed 's/\(TO''DO\)\s*([^)]*)/\1/g' \
+| sed -n 's/^\s*[A-Z_]\+(LIBSYSCALLS_ARCH_\([^)]*\)).*$/\1/p' \
+| sed 's/,\s*/ /g' > $b
+grep '^AMD64 8 64 64 Little TWOS_COMPLEMENT' >/dev/null < $b
+grep '^AMD64_X32 8 32 32 Little TWOS_COMPLEMENT' >/dev/null < $b
+grep '^M68K 8 32 32 Big TWOS_COMPLEMENT' >/dev/null < $b
+grep '^PARISC_32 8 32 32 Big TWOS_COMPLEMENT' >/dev/null < $b
+grep '^PARISC_64 8 64 64 Big TWOS_COMPLEMENT' >/dev/null < $b
+grep '^SPARC_32 8 32 32 Big TWOS_COMPLEMENT' >/dev/null < $b
+grep '^I386 8 32 32 Little TWOS_COMPLEMENT' >/dev/null < $b
+archinfo="$(cat $b)"
+getbytesize () {
+ printf '%s\n' "$archinfo" | grep "^$1 " | cut -d ' ' -f 2
+}
+getaddrsize () {
+ printf '%s\n' "$archinfo" | grep "^$1 " | cut -d ' ' -f 3
+}
+getsizesize () {
+ printf '%s\n' "$archinfo" | grep "^$1 " | cut -d ' ' -f 4
+}
+getendian () {
+ printf '%s\n' "$archinfo" | grep "^$1 " | cut -d ' ' -f 5
+}
+getsign () {
+ printf '%s\n' "$archinfo" | grep "^$1 " | cut -d ' ' -f 6
+}
+
+whole=$(getnum SECTION WHOLE)
+noannotation=$(getnum ANNOTATION NONE)
+for os in $(getnamelist OS); do
+ osn=$(getnum OS $os)
+ for arch in $(getnamelist ARCH); do
+ archn=$(getnum ARCH $arch)
+ if ! issupported $os $arch; then
+ continue
+ fi
+
+ endian=$(getendian $arch)
+
+ sign_representation=$(getsign $arch)
+ if test ${sign_representation} = TWOS_COMPLEMENT; then
+ min_is_minus_max=0
+ elif test ${sign_representation} = ONES_COMPLEMENT; then
+ min_is_minus_max=1
+ elif test ${sign_representation} = SIGN_MAGNITUDE; then
+ min_is_minus_max=1
+ elif test ${sign_representation} = EXCESS_HALF; then
+ min_is_minus_max=0
+ else
+ false
+ fi
+ sign_representation=$(getnum SIGN ${sign_representation})
+
+ for n in $intsizes; do
+ type=INT$n
+ desc="$(get-datatype-description.tu $osn $archn $(lookupnum "$types" $type) $os $arch $type)"
+ printf '%s\n' "$desc" | grep "^width_in_bits = ${n}"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^array_size = 1"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^relative_position_of_array_size = 0"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^absolute_position_of_array_size = -1"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^is_signed = 1"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^is_unsigned = 0"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^min_is_minus_max = ${min_is_minus_max}"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^sign_representation = ${sign_representation}"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^annotation = ${noannotation}"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^section = ${whole}"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^byteorder = $(getbyteorder $n $endian)"\$ >/dev/null
+ done
+ for n in $intsizes; do
+ type=UINT$n
+ desc="$(get-datatype-description.tu $osn $archn $(lookupnum "$types" $type) $os $arch $type)"
+ printf '%s\n' "$desc" | grep "^width_in_bits = ${n}"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^array_size = 1"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^relative_position_of_array_size = 0"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^absolute_position_of_array_size = -1"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^is_signed = 0"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^is_unsigned = 1"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^annotation = ${noannotation}"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^section = ${whole}"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^byteorder = $(getbyteorder $n $endian)"\$ >/dev/null
+ done
+
+ type=VOID
+ desc="$(get-datatype-description.tu $osn $archn $(lookupnum "$types" $type) $os $arch $type | tee $a)"
+ printf '%s\n' "$desc" | grep "^width_in_bits = 0"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^array_size = 1"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^relative_position_of_array_size = 0"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^absolute_position_of_array_size = -1"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^is_signed = 0"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^is_unsigned = 0"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^annotation = ${noannotation}"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^section = ${whole}"\$ >/dev/null
+ printf '%s\n' "$desc" | grep "^byteorder =\s*"\$ >/dev/null
+ type=NO_RETURN
+ get-datatype-description.tu $osn $archn $(lookupnum "$types" $type) $os $arch $type | diff -u $a -
+
+ type=INT
+ get-datatype-description.tu $osn $archn $(lookupnum "$types" $type) $os $arch $type > $a
+ type=INT_SIGNAL
+ get-datatype-description.tu $osn $archn $(lookupnum "$types" $type) $os $arch $type > $b
+ sed 's/^\(annotation\) .*$/\1 = '"$(getnum ANNOTATION SIGNAL)"'/' < $a | diff -u - $b
+ type=INT_FD
+ get-datatype-description.tu $osn $archn $(lookupnum "$types" $type) $os $arch $type > $b
+ sed 's/^\(annotation\) .*$/\1 = '"$(getnum ANNOTATION FD)"'/' < $a | diff -u - $b
+ type=INT_ATFD
+ get-datatype-description.tu $osn $archn $(lookupnum "$types" $type) $os $arch $type > $b
+ sed 's/^\(annotation\) .*$/\1 = '"$(getnum ANNOTATION ATFD)"'/' < $a | diff -u - $b
+
+ type=LONG
+ get-datatype-description.tu $osn $archn $(lookupnum "$types" $type) $os $arch $type > $a
+ type=LONG_FD
+ get-datatype-description.tu $osn $archn $(lookupnum "$types" $type) $os $arch $type > $b
+ sed 's/^\(annotation\) .*$/\1 = '"$(getnum ANNOTATION FD)"'/' < $a | diff -u - $b
+ type=LONG_ATFD
+ get-datatype-description.tu $osn $archn $(lookupnum "$types" $type) $os $arch $type > $b
+ sed 's/^\(annotation\) .*$/\1 = '"$(getnum ANNOTATION ATFD)"'/' < $a | diff -u - $b
+
+ for type in SCHAR SHORT INT LONG LLONG PTRDIFF INTPTR SSIZE; do
+ if test $type = SCHAR; then
+ utype=UCHAR
+ elif test $type = SSIZE; then
+ utype=SIZE
+ else
+ utype=U$type
+ fi
+
+ get-datatype-description.tu $osn $archn $(lookupnum "$types" $type) $os $arch $type > $a
+ grep "^width_in_bits = ." < $a >/dev/null
+ grep "^array_size = 1"\$ < $a >/dev/null
+ grep "^relative_position_of_array_size = 0"\$ < $a >/dev/null
+ grep "^absolute_position_of_array_size = -1"\$ < $a >/dev/null
+ grep "^is_signed = 1"\$ < $a >/dev/null
+ grep "^is_unsigned = 0"\$ < $a >/dev/null
+ grep "^min_is_minus_max = ${min_is_minus_max}"\$ < $a >/dev/null
+ grep "^sign_representation = ${sign_representation}"\$ < $a >/dev/null
+ grep "^annotation = ${noannotation}"\$ < $a >/dev/null
+ grep "^section = ${whole}"\$ < $a >/dev/null
+ n="$(grep "^width_in_bits = ." < $a | cut -d ' ' -f 3)"
+ grep "^byteorder = $(getbyteorder $n $endian)"\$ < $a >/dev/null
+
+ sed -e 's/^\(is_signed =\) .$/\1 0/' -e 's/^\(is_unsigned =\) .$/\1 1/' < $a > $b
+ ( ! diff -u $b $a > /dev/null)
+ grep -v '^\(min_is_minus_max\|sign_representation\) = ' < $b > $a
+ ( ! diff -u $a $b > /dev/null)
+ get-datatype-description.tu $osn $archn $(lookupnum "$types" $utype) $os $arch $utype > $b
+ grep -v '^\(min_is_minus_max\|sign_representation\) = ' < $b | diff -u $a -
+
+ if test $type = SCHAR; then
+ xtypes=CHAR
+ elif test $type = INTPTR; then
+ xtypes="MEMORY_ADDRESS STRING STRINGS_THEN_NULL"
+ else
+ xtypes=
+ fi
+ for xtype in $xtypes; do
+ get-datatype-description.tu $osn $archn $(lookupnum "$types" $xtype) $os $arch $xtype \
+ | grep -v '^\(min_is_minus_max\|sign_representation\) = ' > $b
+ sed 's/^\(is_\(un\)signed =\) .$/\1 0/' < $a | diff -u - $b
+ done
+ done
+
+ type=INTPTR
+ get-datatype-description.tu $osn $archn $(lookupnum "$types" $type) $os $arch $type > $a
+ type=PTRDIFF
+ get-datatype-description.tu $osn $archn $(lookupnum "$types" $type) $os $arch $type > $b
+ diff -u $a $b
+
+ type=DYNAMIC
+ get-datatype-description.tu $osn $archn $(lookupnum "$types" $type) $os $arch $type > $a
+ type=UNKNOWN
+ get-datatype-description.tu $osn $archn $(lookupnum "$types" $type) $os $arch $type > $b
+ diff -u $a $b
+ done
+done
+
+printf '%s\n' "$types" | grep STRUCT >/dev/null
+printf '%s\n' "$types" | grep UNION >/dev/null
+structs="$(printf '%s\n' "$types" | grep '\(STRUCT\|UNION\)' | cut -d ' ' -f 1)"
+int=$(lookupnum "$types" INT)
+for os in $(getnamelist OS); do
+ osn=$(getnum OS $os)
+ for arch in $(getnamelist ARCH); do
+ archn=$(getnum ARCH $arch)
+ if ! issupported $os $arch; then
+ continue
+ fi
+ ( ! is-datatype-struct.tu $osn $archn $int $os $arch INT )
+ for type in $structs; do
+ is-datatype-struct.tu $osn $archn $type $os $arch 'some struct or union'
+ done
+ done
+done
+
+
+
+# TODO test libsyscalls_get_syscall
+# TODO test libsyscalls_get_syscall_display_info
diff --git a/testcases/errors-LINUX-AMD64 b/testcases/errors-LINUX-AMD64
new file mode 100644
index 0000000..c48ca78
--- /dev/null
+++ b/testcases/errors-LINUX-AMD64
@@ -0,0 +1,150 @@
+1 1 EPERM
+2 2 ENOENT
+3 3 ESRCH
+4 4 EINTR
+5 5 EIO
+6 6 ENXIO
+7 7 E2BIG
+8 8 ENOEXEC
+9 9 EBADF
+10 10 ECHILD
+11 11 EAGAIN
+12 12 ENOMEM
+13 13 EACCES
+14 14 EFAULT
+15 15 ENOTBLK
+16 16 EBUSY
+17 17 EEXIST
+18 18 EXDEV
+19 19 ENODEV
+20 20 ENOTDIR
+21 21 EISDIR
+22 22 EINVAL
+23 23 ENFILE
+24 24 EMFILE
+25 25 ENOTTY
+26 26 ETXTBSY
+27 27 EFBIG
+28 28 ENOSPC
+29 29 ESPIPE
+30 30 EROFS
+31 31 EMLINK
+32 32 EPIPE
+33 33 EDOM
+34 34 ERANGE
+35 35 EDEADLK
+36 36 ENAMETOOLONG
+37 37 ENOLCK
+38 38 ENOSYS
+39 39 ENOTEMPTY
+40 40 ELOOP
+42 42 ENOMSG
+43 43 EIDRM
+44 44 ECHRNG
+45 45 EL2NSYNC
+46 46 EL3HLT
+47 47 EL3RST
+48 48 ELNRNG
+49 49 EUNATCH
+50 50 ENOCSI
+51 51 EL2HLT
+52 52 EBADE
+53 53 EBADR
+54 54 EXFULL
+55 55 ENOANO
+56 56 EBADRQC
+57 57 EBADSLT
+59 59 EBFONT
+60 60 ENOSTR
+61 61 ENODATA
+62 62 ETIME
+63 63 ENOSR
+64 64 ENONET
+65 65 ENOPKG
+66 66 EREMOTE
+67 67 ENOLINK
+68 68 EADV
+69 69 ESRMNT
+70 70 ECOMM
+71 71 EPROTO
+72 72 EMULTIHOP
+73 73 EDOTDOT
+74 74 EBADMSG
+75 75 EOVERFLOW
+76 76 ENOTUNIQ
+77 77 EBADFD
+78 78 EREMCHG
+79 79 ELIBACC
+80 80 ELIBBAD
+81 81 ELIBSCN
+82 82 ELIBMAX
+83 83 ELIBEXEC
+84 84 EILSEQ
+85 85 ERESTART
+86 86 ESTRPIPE
+87 87 EUSERS
+88 88 ENOTSOCK
+89 89 EDESTADDRREQ
+90 90 EMSGSIZE
+91 91 EPROTOTYPE
+92 92 ENOPROTOOPT
+93 93 EPROTONOSUPPORT
+94 94 ESOCKTNOSUPPORT
+95 95 EOPNOTSUPP
+96 96 EPFNOSUPPORT
+97 97 EAFNOSUPPORT
+98 98 EADDRINUSE
+99 99 EADDRNOTAVAIL
+100 100 ENETDOWN
+101 101 ENETUNREACH
+102 102 ENETRESET
+103 103 ECONNABORTED
+104 104 ECONNRESET
+105 105 ENOBUFS
+106 106 EISCONN
+107 107 ENOTCONN
+108 108 ESHUTDOWN
+109 109 ETOOMANYREFS
+110 110 ETIMEDOUT
+111 111 ECONNREFUSED
+112 112 EHOSTDOWN
+113 113 EHOSTUNREACH
+114 114 EALREADY
+115 115 EINPROGRESS
+116 116 ESTALE
+117 117 EUCLEAN
+118 118 ENOTNAM
+119 119 ENAVAIL
+120 120 EISNAM
+121 121 EREMOTEIO
+122 122 EDQUOT
+123 123 ENOMEDIUM
+124 124 EMEDIUMTYPE
+125 125 ECANCELED
+126 126 ENOKEY
+127 127 EKEYEXPIRED
+128 128 EKEYREVOKED
+129 129 EKEYREJECTED
+130 130 EOWNERDEAD
+131 131 ENOTRECOVERABLE
+132 132 ERFKILL
+133 133 EHWPOISON
+512 512 ERESTARTSYS
+513 513 ERESTARTNOINTR
+514 514 ERESTARTNOHAND
+515 515 ENOIOCTLCMD
+516 516 ERESTART_RESTARTBLOCK
+517 517 EPROBE_DEFER
+518 518 EOPENSTALE
+519 519 ENOPARAM
+521 521 EBADHANDLE
+522 522 ENOTSYNC
+523 523 EBADCOOKIE
+524 524 ENOTSUPP
+525 525 ETOOSMALL
+526 526 ESERVERFAULT
+527 527 EBADTYPE
+528 528 EJUKEBOX
+529 529 EIOCBQUEUED
+530 530 ERECALLCONFLICT
+531 531 ENOGRACE
diff --git a/testcases/errors-LINUX-PARISC_32 b/testcases/errors-LINUX-PARISC_32
new file mode 100644
index 0000000..eda7276
--- /dev/null
+++ b/testcases/errors-LINUX-PARISC_32
@@ -0,0 +1,152 @@
+1 1 EPERM
+2 2 ENOENT
+3 3 ESRCH
+4 4 EINTR
+5 5 EIO
+6 6 ENXIO
+7 7 E2BIG
+8 8 ENOEXEC
+9 9 EBADF
+10 10 ECHILD
+11 11 EAGAIN
+12 12 ENOMEM
+13 13 EACCES
+14 14 EFAULT
+15 15 ENOTBLK
+16 16 EBUSY
+17 17 EEXIST
+18 18 EXDEV
+19 19 ENODEV
+20 20 ENOTDIR
+21 21 EISDIR
+22 22 EINVAL
+23 23 ENFILE
+24 24 EMFILE
+25 25 ENOTTY
+26 26 ETXTBSY
+27 27 EFBIG
+28 28 ENOSPC
+29 29 ESPIPE
+30 30 EROFS
+31 31 EMLINK
+32 32 EPIPE
+33 33 EDOM
+34 34 ERANGE
+35 35 ENOMSG
+36 36 EIDRM
+37 37 ECHRNG
+38 38 EL2NSYNC
+39 39 EL3HLT
+40 40 EL3RST
+41 41 ELNRNG
+42 42 EUNATCH
+43 43 ENOCSI
+44 44 EL2HLT
+45 45 EDEADLK
+46 46 ENOLCK
+47 47 EILSEQ
+50 50 ENONET
+51 51 ENODATA
+52 52 ETIME
+53 53 ENOSR
+54 54 ENOSTR
+55 55 ENOPKG
+57 57 ENOLINK
+58 58 EADV
+59 59 ESRMNT
+60 60 ECOMM
+61 61 EPROTO
+64 64 EMULTIHOP
+66 66 EDOTDOT
+67 67 EBADMSG
+68 68 EUSERS
+69 69 EDQUOT
+70 70 ESTALE
+71 71 EREMOTE
+72 72 EOVERFLOW
+160 160 EBADE
+161 161 EBADR
+162 162 EXFULL
+163 163 ENOANO
+164 164 EBADRQC
+165 165 EBADSLT
+166 166 EBFONT
+167 167 ENOTUNIQ
+168 168 EBADFD
+169 169 EREMCHG
+170 170 ELIBACC
+171 171 ELIBBAD
+172 172 ELIBSCN
+173 173 ELIBMAX
+174 174 ELIBEXEC
+175 175 ERESTART
+176 176 ESTRPIPE
+177 177 EUCLEAN
+178 178 ENOTNAM
+179 179 ENAVAIL
+180 180 EISNAM
+181 181 EREMOTEIO
+182 182 ENOMEDIUM
+183 183 EMEDIUMTYPE
+184 184 ENOKEY
+185 185 EKEYEXPIRED
+186 186 EKEYREVOKED
+187 187 EKEYREJECTED
+215 215 ENOSYM
+216 216 ENOTSOCK
+217 217 EDESTADDRREQ
+218 218 EMSGSIZE
+219 219 EPROTOTYPE
+220 220 ENOPROTOOPT
+221 221 EPROTONOSUPPORT
+222 222 ESOCKTNOSUPPORT
+223 223 EOPNOTSUPP
+224 224 EPFNOSUPPORT
+225 225 EAFNOSUPPORT
+226 226 EADDRINUSE
+227 227 EADDRNOTAVAIL
+228 228 ENETDOWN
+229 229 ENETUNREACH
+230 230 ENETRESET
+231 231 ECONNABORTED
+232 232 ECONNRESET
+233 233 ENOBUFS
+234 234 EISCONN
+235 235 ENOTCONN
+236 236 ESHUTDOWN
+237 237 ETOOMANYREFS
+238 238 ETIMEDOUT
+239 239 ECONNREFUSED
+240 240 EREMOTERELEASE
+241 241 EHOSTDOWN
+242 242 EHOSTUNREACH
+244 244 EALREADY
+245 245 EINPROGRESS
+247 247 ENOTEMPTY
+248 248 ENAMETOOLONG
+249 249 ELOOP
+251 251 ENOSYS
+253 253 ECANCELLED
+254 254 EOWNERDEAD
+255 255 ENOTRECOVERABLE
+256 256 ERFKILL
+257 257 EHWPOISON
+512 512 ERESTARTSYS
+513 513 ERESTARTNOINTR
+514 514 ERESTARTNOHAND
+515 515 ENOIOCTLCMD
+516 516 ERESTART_RESTARTBLOCK
+517 517 EPROBE_DEFER
+518 518 EOPENSTALE
+519 519 ENOPARAM
+521 521 EBADHANDLE
+522 522 ENOTSYNC
+523 523 EBADCOOKIE
+524 524 ENOTSUPP
+525 525 ETOOSMALL
+526 526 ESERVERFAULT
+527 527 EBADTYPE
+528 528 EJUKEBOX
+529 529 EIOCBQUEUED
+530 530 ERECALLCONFLICT
+531 531 ENOGRACE
diff --git a/testcases/errors-LINUX-PARISC_64 b/testcases/errors-LINUX-PARISC_64
new file mode 120000
index 0000000..f5c14d9
--- /dev/null
+++ b/testcases/errors-LINUX-PARISC_64
@@ -0,0 +1 @@
+errors-LINUX-PARISC_32 \ No newline at end of file
diff --git a/testcases/signals-LINUX-AMD64 b/testcases/signals-LINUX-AMD64
new file mode 100644
index 0000000..4bc3c5d
--- /dev/null
+++ b/testcases/signals-LINUX-AMD64
@@ -0,0 +1,64 @@
+1 1 SIGHUP
+2 2 SIGINT
+3 3 SIGQUIT
+4 4 SIGILL
+5 5 SIGTRAP
+6 6 SIGABRT
+7 7 SIGBUS
+8 8 SIGFPE
+9 9 SIGKILL
+10 10 SIGUSR1
+11 11 SIGSEGV
+12 12 SIGUSR2
+13 13 SIGPIPE
+14 14 SIGALRM
+15 15 SIGTERM
+16 16 SIGSTKFLT
+17 17 SIGCHLD
+18 18 SIGCONT
+19 19 SIGSTOP
+20 20 SIGTSTP
+21 21 SIGTTIN
+22 22 SIGTTOU
+23 23 SIGURG
+24 24 SIGXCPU
+25 25 SIGXFSZ
+26 26 SIGVTALRM
+27 27 SIGPROF
+28 28 SIGWINCH
+29 29 SIGIO
+30 30 SIGPWR
+31 31 SIGSYS
+32 32 _SIGRTMIN
+33 33 _SIGRTMIN+1
+34 34 _SIGRTMIN+2
+35 35 _SIGRTMIN+3
+36 36 _SIGRTMIN+4
+37 37 _SIGRTMIN+5
+38 38 _SIGRTMIN+6
+39 39 _SIGRTMIN+7
+40 40 _SIGRTMIN+8
+41 41 _SIGRTMIN+9
+42 42 _SIGRTMIN+10
+43 43 _SIGRTMIN+11
+44 44 _SIGRTMIN+12
+45 45 _SIGRTMIN+13
+46 46 _SIGRTMIN+14
+47 47 _SIGRTMIN+15
+48 48 _SIGRTMIN+16
+49 49 _SIGRTMIN+17
+50 50 _SIGRTMIN+18
+51 51 _SIGRTMIN+19
+52 52 _SIGRTMIN+20
+53 53 _SIGRTMIN+21
+54 54 _SIGRTMIN+22
+55 55 _SIGRTMIN+23
+56 56 _SIGRTMIN+24
+57 57 _SIGRTMIN+25
+58 58 _SIGRTMIN+26
+59 59 _SIGRTMIN+27
+60 60 _SIGRTMIN+28
+61 61 _SIGRTMIN+29
+62 62 _SIGRTMIN+30
+63 63 _SIGRTMIN+31
+64 64 _SIGRTMIN+32
diff --git a/testutil/get-datatype-description.c b/testutil/get-datatype-description.c
new file mode 100644
index 0000000..0bec618
--- /dev/null
+++ b/testutil/get-datatype-description.c
@@ -0,0 +1,52 @@
+/* See LICENSE file for copyright and license details. */
+#include "../libsyscalls.h"
+
+#include <limits.h>
+#include <stddef.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+
+int
+main(int argc, char *argv[])
+{
+ enum libsyscalls_os os = (enum libsyscalls_os)atoi(argv[1]);
+ enum libsyscalls_arch arch = (enum libsyscalls_arch)atoi(argv[2]);
+ enum libsyscalls_datatype type = (enum libsyscalls_datatype)atoi(argv[3]);
+ struct libsyscalls_datatype_description desc;
+ enum libsyscalls_error err;
+ size_t i;
+
+ err = libsyscalls_get_datatype_description(os, arch, type, &desc);
+ if (err) {
+ fprintf(stderr, "libsyscalls_get_datatype_description %s %s %s: ", argv[4], argv[5], argv[6]);
+ libsyscalls_perror(NULL, err);
+ return 1;
+ }
+
+ printf("width_in_bits = %u\n", desc.width_in_bits);
+ printf("array_size = %u\n", desc.array_size);
+ printf("relative_position_of_array_size = %i\n", desc.relative_position_of_array_size);
+ printf("absolute_position_of_array_size = %i\n", desc.absolute_position_of_array_size);
+ printf("fill_is_known = %u\n", desc.fill_is_known);
+ printf("is_signed = %u\n", desc.is_signed);
+ printf("is_unsigned = %u\n", desc.is_unsigned);
+ printf("min_is_minus_max = %u\n", desc.min_is_minus_max);
+ printf("sign_representation = %lli\n", (long long int)desc.sign_representation);
+ printf("annotation = %lli\n", (long long int)desc.annotation);
+ printf("section = %lli\n", (long long int)desc.section);
+ printf("byteorder =");
+ for (i = 0; i < sizeof(desc.byteorder) / sizeof(*desc.byteorder); i++) {
+ if (LIBSYSCALLS_IS_BYTEORDER_END(desc.byteorder[i]))
+ goto end_of_byteorder;
+ printf(" %u", desc.byteorder[i]);
+ }
+end_of_byteorder:
+ printf("\n");
+
+ if (fflush(stdout) || fclose(stdout)) {
+ perror(NULL);
+ return 1;
+ }
+ return 0;
+}
diff --git a/testutil/get-error.c b/testutil/get-error.c
new file mode 100644
index 0000000..8f066d7
--- /dev/null
+++ b/testutil/get-error.c
@@ -0,0 +1,27 @@
+/* See LICENSE file for copyright and license details. */
+#include "../libsyscalls.h"
+
+#include <stddef.h>
+#include <stdio.h>
+#include <string.h>
+
+
+int
+main(int argc, char *argv[])
+{
+ int i;
+
+ for (i = 1; i < argc; i++) {
+#define X(N, S)\
+ if (!strcmp(argv[i], #N))\
+ printf("%s\n", S)
+ LIBSYSCALLS_LIST_ERRORS(X, ;);
+#undef X
+ }
+
+ if (fflush(stdout) || fclose(stdout)) {
+ perror(NULL);
+ return 1;
+ }
+ return 0;
+}
diff --git a/testutil/get-section-fraction.c b/testutil/get-section-fraction.c
new file mode 100644
index 0000000..cdb1530
--- /dev/null
+++ b/testutil/get-section-fraction.c
@@ -0,0 +1,24 @@
+/* See LICENSE file for copyright and license details. */
+#include "../libsyscalls.h"
+
+#include <stddef.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+
+int
+main(int argc, char *argv[])
+{
+ enum libsyscalls_datatype_section sec;
+
+ (void) argc;
+
+ sec = (enum libsyscalls_datatype_section)atoi(argv[1]);
+ printf("%u\n", LIBSYSCALLS_GET_SECTION_FRACTION(sec));
+
+ if (fflush(stdout) || fclose(stdout)) {
+ perror(NULL);
+ return 1;
+ }
+ return 0;
+}
diff --git a/testutil/get-signals.c b/testutil/get-signals.c
new file mode 100644
index 0000000..846a0c1
--- /dev/null
+++ b/testutil/get-signals.c
@@ -0,0 +1,43 @@
+/* See LICENSE file for copyright and license details. */
+#include "../libsyscalls.h"
+
+#include <stddef.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+
+int
+main(int argc, char *argv[])
+{
+ enum libsyscalls_os os;
+ enum libsyscalls_arch arch;
+ const struct libsyscalls_named_number *signals;
+ size_t i, nsignals;
+ enum libsyscalls_error err;
+
+ (void) argc;
+
+ os = (enum libsyscalls_os)atoi(argv[1]);
+ arch = (enum libsyscalls_arch)atoi(argv[2]);
+
+ libsyscalls_get_signals(os, arch, &signals, &nsignals);
+ if (err == LIBSYSCALLS_E_OSNOSUP || err == LIBSYSCALLS_E_ARCHNOSUP) {
+ printf("x\n");
+ return 0;
+ } else if (err == LIBSYSCALLS_E_NOSIGNALS) {
+ return 0;
+ } else if (err) {
+ fprintf(stderr, "test-get-syscall-signals %s %s: ", argv[3], argv[4]);
+ libsyscalls_perror(NULL, err);
+ return 1;
+ }
+
+ for (i = 0; i < nsignals; i++)
+ printf("%lli %llu %s\n", signals[i].number.s, signals[i].number.u, signals[i].name);
+
+ if (fflush(stdout) || fclose(stdout)) {
+ perror(NULL);
+ return 1;
+ }
+ return 0;
+}
diff --git a/testutil/get-syscall-errors.c b/testutil/get-syscall-errors.c
new file mode 100644
index 0000000..c97e556
--- /dev/null
+++ b/testutil/get-syscall-errors.c
@@ -0,0 +1,43 @@
+/* See LICENSE file for copyright and license details. */
+#include "../libsyscalls.h"
+
+#include <stddef.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+
+int
+main(int argc, char *argv[])
+{
+ enum libsyscalls_os os;
+ enum libsyscalls_arch arch;
+ const struct libsyscalls_named_number *errors;
+ size_t i, nerrors;
+ enum libsyscalls_error err;
+
+ (void) argc;
+
+ os = (enum libsyscalls_os)atoi(argv[1]);
+ arch = (enum libsyscalls_arch)atoi(argv[2]);
+
+ libsyscalls_get_syscall_errors(os, arch, &errors, &nerrors);
+ if (err == LIBSYSCALLS_E_OSNOSUP || err == LIBSYSCALLS_E_ARCHNOSUP) {
+ printf("x\n");
+ return 0;
+ } else if (err == LIBSYSCALLS_E_NOERRORS) {
+ return 0;
+ } else if (err) {
+ fprintf(stderr, "test-get-syscall-errors %s %s: ", argv[3], argv[4]);
+ libsyscalls_perror(NULL, err);
+ return 1;
+ }
+
+ for (i = 0; i < nerrors; i++)
+ printf("%lli %llu %s\n", errors[i].number.s, errors[i].number.u, errors[i].name);
+
+ if (fflush(stdout) || fclose(stdout)) {
+ perror(NULL);
+ return 1;
+ }
+ return 0;
+}
diff --git a/testutil/get-syscall-range.c b/testutil/get-syscall-range.c
new file mode 100644
index 0000000..9f26b8e
--- /dev/null
+++ b/testutil/get-syscall-range.c
@@ -0,0 +1,41 @@
+/* See LICENSE file for copyright and license details. */
+#include "../libsyscalls.h"
+
+#include <stddef.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+
+int
+main(int argc, char *argv[])
+{
+ enum libsyscalls_os os;
+ enum libsyscalls_arch arch;
+ long long int min, max;
+ enum libsyscalls_error err;
+
+ (void) argc;
+
+ os = (enum libsyscalls_os)atoi(argv[1]);
+ arch = (enum libsyscalls_arch)atoi(argv[2]);
+
+ err = libsyscalls_get_syscall_range(os, arch, &min, &max);
+ if (err == LIBSYSCALLS_E_OSNOSUP || err == LIBSYSCALLS_E_ARCHNOSUP) {
+ printf("min: x\n");
+ printf("max: x\n");
+ return 0;
+ } else if (err) {
+ fprintf(stderr, "test-get-syscall-range %s %s: ", argv[3], argv[4]);
+ libsyscalls_perror(NULL, err);
+ return 1;
+ }
+
+ printf("min: %lli\n", min);
+ printf("max: %lli\n", max);
+
+ if (fflush(stdout) || fclose(stdout)) {
+ perror(NULL);
+ return 1;
+ }
+ return 0;
+}
diff --git a/testutil/is-datatype-struct.c b/testutil/is-datatype-struct.c
new file mode 100644
index 0000000..f1c7675
--- /dev/null
+++ b/testutil/is-datatype-struct.c
@@ -0,0 +1,29 @@
+/* See LICENSE file for copyright and license details. */
+#include "../libsyscalls.h"
+
+#include <limits.h>
+#include <stddef.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+
+int
+main(int argc, char *argv[])
+{
+ enum libsyscalls_os os = (enum libsyscalls_os)atoi(argv[1]);
+ enum libsyscalls_arch arch = (enum libsyscalls_arch)atoi(argv[2]);
+ enum libsyscalls_datatype type = (enum libsyscalls_datatype)atoi(argv[3]);
+ struct libsyscalls_datatype_description desc;
+ enum libsyscalls_error err;
+ size_t i;
+
+ err = libsyscalls_get_datatype_description(os, arch, type, &desc);
+ if (err == LIBSYSCALLS_E_ISSTRUCT) {
+ return 0;
+ } else if (err) {
+ fprintf(stderr, "libsyscalls_get_datatype_description %s %s %s: ", argv[4], argv[5], argv[6]);
+ libsyscalls_perror(NULL, err);
+ return 2;
+ }
+ return 1;
+}
diff --git a/testutil/is-section-half.c b/testutil/is-section-half.c
new file mode 100644
index 0000000..ee6ef50
--- /dev/null
+++ b/testutil/is-section-half.c
@@ -0,0 +1,14 @@
+/* See LICENSE file for copyright and license details. */
+#include "../libsyscalls.h"
+
+#include <stdlib.h>
+
+
+int
+main(int argc, char *argv[])
+{
+ enum libsyscalls_datatype_section sec;
+ (void) argc;
+ sec = (enum libsyscalls_datatype_section)atoi(argv[1]);
+ return !LIBSYSCALLS_IS_SECTION_HALF(sec);
+}
diff --git a/testutil/is-section-quarter.c b/testutil/is-section-quarter.c
new file mode 100644
index 0000000..1fe28d2
--- /dev/null
+++ b/testutil/is-section-quarter.c
@@ -0,0 +1,14 @@
+/* See LICENSE file for copyright and license details. */
+#include "../libsyscalls.h"
+
+#include <stdlib.h>
+
+
+int
+main(int argc, char *argv[])
+{
+ enum libsyscalls_datatype_section sec;
+ (void) argc;
+ sec = (enum libsyscalls_datatype_section)atoi(argv[1]);
+ return !LIBSYSCALLS_IS_SECTION_QUARTER(sec);
+}
diff --git a/testutil/list-errors.c b/testutil/list-errors.c
new file mode 100644
index 0000000..5738b06
--- /dev/null
+++ b/testutil/list-errors.c
@@ -0,0 +1,21 @@
+/* See LICENSE file for copyright and license details. */
+#include "../libsyscalls.h"
+
+#include <stddef.h>
+#include <stdio.h>
+
+
+int
+main(void)
+{
+#define X(N, S)\
+ printf("%li %s %s\n", (long int)N, #N, S)
+ LIBSYSCALLS_LIST_ERRORS(X, ;);
+#undef X
+
+ if (fflush(stdout) || fclose(stdout)) {
+ perror(NULL);
+ return 1;
+ }
+ return 0;
+}
diff --git a/testutil/perror-all.c b/testutil/perror-all.c
new file mode 100644
index 0000000..2b37cff
--- /dev/null
+++ b/testutil/perror-all.c
@@ -0,0 +1,23 @@
+/* See LICENSE file for copyright and license details. */
+#include "../libsyscalls.h"
+
+#include <stddef.h>
+#include <stdio.h>
+
+
+int
+main(int argc, char *argv[])
+{
+ size_t i, count;
+
+ (void) argc;
+
+#define X(...) 1
+ count = (LIBSYSCALLS_LIST_ERRORS(X, +));
+#undef X
+
+ for (i = 0; i < count; i++)
+ libsyscalls_perror(argv[1], (enum libsyscalls_error)i);
+
+ return fflush(stderr) || fclose(stderr);
+}
diff --git a/testutil/perror-bad.c b/testutil/perror-bad.c
new file mode 100644
index 0000000..55d36d3
--- /dev/null
+++ b/testutil/perror-bad.c
@@ -0,0 +1,23 @@
+/* See LICENSE file for copyright and license details. */
+#include "../libsyscalls.h"
+
+#include <stddef.h>
+#include <stdio.h>
+
+
+int
+main(int argc, char *argv[])
+{
+ size_t count;
+
+ (void) argc;
+
+#define X(...) 1
+ count = (LIBSYSCALLS_LIST_ERRORS(X, +));
+#undef X
+
+ libsyscalls_perror(argv[1], (enum libsyscalls_error)-1);
+ libsyscalls_perror(argv[1], (enum libsyscalls_error)count);
+
+ return fflush(stderr) || fclose(stderr);
+}
diff --git a/testutil/strerror-all.c b/testutil/strerror-all.c
new file mode 100644
index 0000000..b875392
--- /dev/null
+++ b/testutil/strerror-all.c
@@ -0,0 +1,25 @@
+/* See LICENSE file for copyright and license details. */
+#include "../libsyscalls.h"
+
+#include <stddef.h>
+#include <stdio.h>
+
+
+int
+main(void)
+{
+ size_t i, count;
+
+#define X(...) 1
+ count = (LIBSYSCALLS_LIST_ERRORS(X, +));
+#undef X
+
+ for (i = 0; i < count; i++)
+ printf("%s\n", libsyscalls_strerror((enum libsyscalls_error)i));
+
+ if (fflush(stdout) || fclose(stdout)) {
+ perror(NULL);
+ return 1;
+ }
+ return 0;
+}
diff --git a/testutil/strerror-bad.c b/testutil/strerror-bad.c
new file mode 100644
index 0000000..23d8836
--- /dev/null
+++ b/testutil/strerror-bad.c
@@ -0,0 +1,25 @@
+/* See LICENSE file for copyright and license details. */
+#include "../libsyscalls.h"
+
+#include <stddef.h>
+#include <stdio.h>
+
+
+int
+main(void)
+{
+ size_t count;
+
+#define X(...) 1
+ count = (LIBSYSCALLS_LIST_ERRORS(X, +));
+#undef X
+
+ printf("%s\n", libsyscalls_strerror((enum libsyscalls_error)-1));
+ printf("%s\n", libsyscalls_strerror((enum libsyscalls_error)count));
+
+ if (fflush(stdout) || fclose(stdout)) {
+ perror(NULL);
+ return 1;
+ }
+ return 0;
+}